<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 22/04/2015
 * Time: 17:14
 */

namespace Service\Calendar\Restriction\Strategy;


use Service\Calendar\TaskCalendar;

class DoNotEndBefore extends  RestrictionStrategyAbstract{



    public function getDatesBeginAndEnd($setAllocation = true)
    {
        if($this->task->needScheduleCalcDates()){
            $dateRestriction  = $this->task->getDateException();
            if(!empty($dateRestriction)){
                $dateBegin= clone $this->task->getEstimatedBeginDate();
                $dateEnd = clone $this->task->getEstimatedEndDate();
                if($dateEnd < $dateRestriction){
                    $dateEnd = $dateRestriction;
                }
                $endPrecursor = $this->getDatesByPrecursor($dateBegin,$dateEnd,$setAllocation);
                if($endPrecursor > $dateRestriction){
                    $dateEnd = $endPrecursor;
                }
                $dateBegin = $this->taskCalendar->getDateBegin($this->task,$dateEnd,$setAllocation);
            }else{
                throw new \Exception('Null restriction date');
            }
        }else{
            $dateBegin = $this->task->getEstimatedBeginDate();
            $dateEnd = $this->task->getEstimatedEndDate();
        }
        return array($dateBegin,$dateEnd);
    }

    public function getDatesByPrecursor($beginTask,$endTask,$setAllocation = true)
    {

        if(!$this->task->isContainer()) {
            $datePrecursors = $this->taskCalendar->getDatesPrecursors($this->task, $setAllocation);
            if (!empty($datePrecursors)) {
                foreach ($datePrecursors as $datePrecursor){
                    list($dateBegin, $dateEnd) = $datePrecursor;
                    if ($dateBegin > $beginTask) {
                        $beginTask = $dateBegin;
                        $endTask = $dateEnd;
                    }
                }
            }
        }
        return $endTask;
    }

    public function getDatesMinAndMax($dateBeginMax,$dateEndMin)
    {
        if ($this->task->usesDataControl()) {
            $dateException = $this->task->getDateException();
            if ($dateException) {
                $dateRestriction = clone $this->task->getDateException();
            } else {
                $dateRestriction = clone $this->task->getEstimatedEndDate();
            }
            $dateBegin = $this->taskCalendar->getDateBegin($this->task, $dateRestriction, false);
            if ($dateBeginMax > $dateBegin || is_null($dateBeginMax)) {
                $dateBeginMax = $dateBegin;
            }
        }
        return array($dateBeginMax, $dateEndMin);
    }
}