/* Sistemas Integrados TECNISA

Nome: 0150_GERTRG_DTULTATU_PROSPECT.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela PROSPECT

Criao:
09/09/2003 Alexis Tolentino
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PROSPECT' and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
  DROP TRIGGER DTULTATU_PROSPECT
  GO

CREATE TRIGGER DTULTATU_PROSPECT
ON PROSPECT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PROSPECT', 'CDPROSPECT=' + CDPROSPECT+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PROSPECT
      SET DTULTATUPROS = GETDATE()
      FROM INSERTED
      WHERE
        ISNULL(PROSPECT.CDPROSPECT,0) = ISNULL(INSERTED.CDPROSPECT,0);
   END;
END;
GO

